﻿namespace LithDX
{

class CMatrix
{
public:
	CMatrix();

	double& operator ()(int aX, int aY) { return mData[aX + (aY * 4)]; }
	const double& DataC(int aX, int aY) const { return mData[aX + (aY * 4)]; }

	CMatrix operator *(const CMatrix& aRHS) const;

	CVector Transform(const CVector& aVector) const;

	static CMatrix Identity();
	static CMatrix Rotate(double aXAngle, double aYAngle, double aZAngle);
	static CMatrix RotateAround(const CVector& aVector, double aAngle);
	static CMatrix Translate(const CVector& aOffset);

private:
	double mData[16];
};

}