namespace tlib
{

class TStringBuilder
{
public:
	TStringBuilder();
	~TStringBuilder();

	void Clear();
	TString GetString() const;

	PROPERTY_V(Length, int, FLength)

	void AppendChar(int);
	void AppendChars(int, int);
	void AppendData(int, const wchar_t*);
	void AppendString(TString s) { AppendData(s.Size, s.Str); }

private:
	wchar_t *FData;
	int FCapacity;
	int FSize;
	int FLength;

	void AllocData(int);
};

}   // namespace tlib