﻿enum ECarState { csIdle, csMoving };

class CCar
{
public:
	CCar() { }
	CCar(double aX, double aY, double aAngle, int aType, int aSpeed);

	ECarState GetState() { return mState; }
	double GetX() { return mX; }
	double GetY() { return mY; }
	double GetAngle() { return mAngle; }
	void SetAngle(double aAngle) { mAngle = aAngle; }
	int GetType() { return mType; }

	void Move(double aX, double aY);

	void Update();

private:
	ECarState mState;
	double mX;
	double mY;
	double mAngle;
	int mType;
	int mSpeed;

	int mMoveCounter;
	double mSourceX;
	double mSourceY;
	double mDestX;
	double mDestY;
};