﻿enum EFrogState { fsIdle, fsJumping, fsWaiting };

class CFrog
{
public:
	CFrog() { }
	CFrog(double aX, double aY, double aZ, double aAngle);

	void Jump(int aDistance, int aWaitTime);

	void Update();

	EFrogState GetState() { return mState; }

	double GetX() { return mX; }
	void SetX(double aX) { mX = aX; }
	double GetY() { return mY; }
	void SetY(double aY) { mY = aY; }
	double GetZ() { return mZ; }
	void SetZ(double aZ) { mZ = aZ; }
	double GetAngle() { return mAngle; }
	void SetAngle(double aAngle) { mAngle = aAngle; }

private:
	double mX;
	double mY;
	double mZ;
	double mAngle;

	EFrogState mState;
	int mJumpDistance;
	int mWaitTime;
	int mStep;
};