﻿/*
Frog Rescue - Content pre-loader class
*/

#include <windows.h>
#include <d3d9.h>
#pragma hdrstop

#include "tlib.h"
#include "LithGUI.h"
#include "LithDX.h"
#include "LithUtil.h"

#include "IStuff.h"

#include "CApplication.h"
#include "CPreLoader.h"

using namespace tlib;



CPreLoader::CPreLoader(CApplication* aOwner)
{
	mOwner = aOwner;
}



void CPreLoader::RunThread()
{
	mOwner->GetSprite(SL("Title"));
	for (int i = 0; i < 10; i++)
		mOwner->GetSprite(TString::SPrintF(L"Digit%d", i));
	mOwner->GetSprite(SL("FrogSaved"));
	mOwner->GetSprite(SL("FrogSplatted"));
	mOwner->PreLoadInfo(0);   // title screen data loaded

	mOwner->GetSprite(SL("Cursor"));
	mOwner->GetTexture(SL("Frog"));
	mOwner->GetSound(SL("Jump"));
	mOwner->GetTexture(SL("Road0"));
	mOwner->GetTexture(SL("Road1"));
	mOwner->GetTexture(SL("Road2"));
	mOwner->GetTexture(SL("Road3"));
	mOwner->GetTexture(SL("Road4"));
	mOwner->GetTexture(SL("Road5"));
	mOwner->GetTexture(SL("Road10"));
	mOwner->GetTexture(SL("Car0"));
	mOwner->GetTexture(SL("Car1"));
	mOwner->GetTexture(SL("Car2"));
	mOwner->GetSound(SL("Splat"));
	mOwner->GetTexture(SL("RoadBlock"));

	mOwner->PreLoadInfo(-1);   // finished pre-loading
}